/*
 * Copyright (C) Voltaire Ltd. 2010-2011.  ALL RIGHTS RESERVED.
 * This software product is a proprietary product of Voltaire Ltd.
 * (the "Company") and all right, title, and interest and to the software product,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * This software product is governed by the End User License Agreement
 * provided with the software product.
 * $COPYRIGHT$
 * $HEADER$
 */


#ifndef __SETTINGS_H__
#define __SETTINGS_H__

/**
 * @file pjoin_settings.h
 *
 * @brief Optimization algorithm settings
 */


typedef struct _PjoinSettings PjoinSettings;

/**
 * @struct _PjoinSettings
 *
 * @brief Optimization algorithm settings
 */
struct _PjoinSettings
{
    double switch_latency; /**< time to send message through network link (0.12 by default)*/

    double load_icpu_time; /**< time to load value to icpu (defaltl is 0.50)*/

    double reduce_time; /**< time to do reduce on icpu (per pair of values, default os 0.1)*/

    double offload_icpu_time; /**< time to offload value (reduce result) from icpu (default is 0.6)*/

    double inode_time; /**< Note: this parameter is unused now. Time to calculate reduce result on node (does not depend on number of cores, default is 1.9)*/

    double mcast_send_time; /**< time to start sending multicast from root (default is 0.5)*/

    double mcast_recv_time; /**< time to receive multicast on node (default is 0.8)*/

    int max_children; /**< max number of children (0 means unlimited) */
};

#endif

